# purescript-foreign

[![Latest release](http://img.shields.io/github/release/purescript/purescript-foreign.svg)](https://github.com/purescript/purescript-foreign/releases)
[![Build status](https://github.com/purescript/purescript-foreign/workflows/CI/badge.svg?branch=master)](https://github.com/purescript/purescript-foreign/actions?query=workflow%3ACI+branch%3Amaster)
[![Pursuit](https://pursuit.purescript.org/packages/purescript-foreign/badge)](https://pursuit.purescript.org/packages/purescript-foreign)

Library for dealing with foreign data (JavaScript objects).

## Installation

```
spago install foreign
```

## Examples

- [Simple types](examples/SimpleTypes.purs)
- [Arrays](examples/Arrays.purs)
- [Objects](examples/Objects.purs)
- [Complex objects](examples/Complex.purs)
- [Applicative style parser](examples/Applicative.purs)
- [Maybe for nulls](examples/MaybeNullable.purs)
- [Nested objects](examples/Nested.purs)
- [Unions](examples/Union.purs)
- [Parser errors](examples/ParseErrors.purs)

## Documentation

Module documentation is [published on Pursuit](http://pursuit.purescript.org/packages/purescript-foreign).
